import itertools
import math

def distance(p1, p2):
  return math.sqrt((p1[0] - p2[0])**2 + (p1[1] - p2[1])**2)

def solve():
  n = int(input())
  points = []
  for _ in range(n):
    x, y = map(int, input().split())
    points.append((x, y))

  min_dist = float('inf')
  for perm in itertools.permutations(points):
    total_dist = 0
    for i in range(n - 1):
      total_dist += distance(perm[i], perm[i+1])
    min_dist = min(min_dist, total_dist)

  print(min_dist)

solve()